<?php

namespace Drupal\social_graphql\Plugin\GraphQL\Fields\Facebook;

use Drupal\graphql\GraphQL\Execution\ResolveContext;
use Drupal\graphql\Plugin\GraphQL\Fields\FieldPluginBase;
use GraphQL\Type\Definition\ResolveInfo;

/**
 * @GraphQLField(
 *   id = "social_graphql_facebook_user_fields",
 *   secure = true,
 *   type = "String",
 *   name = "socialGraphQLFacebookUserFields",
 *   parents = {"SocialGraphQLFacebookUser"},
 *   social_gql_object = "user",
 *   deriver =
 *   "Drupal\social_graphql\Plugin\Deriver\Facebook\SocialGraphQlFacebookFieldsDeriver"
 * )
 */
class SocialGraphQLFacebookUserField extends FieldPluginBase {

  /**
   * {@inheritdoc}
   */
  public function resolveValues($value, array $args, ResolveContext $context, ResolveInfo $info) {
    // Fetch the user value.
    $definition = $this->getPluginDefinition();
    if (!empty($value['user']->{$definition['field_name']})) {
      yield $value['user']->{$definition['field_name']};
    }

  }

}
